Index: unk/src/VBox/Runtime/r0drv/solaris/vbi/i86pc/Makefile.files
===================================================================
--- /trunk/src/VBox/Runtime/r0drv/solaris/vbi/i86pc/Makefile.files	(revision 40049)
+++ 	(revision )
@@ -1,235 +1,0 @@
-#
-# CDDL HEADER START
-#
-# The contents of this file are subject to the terms of the
-# Common Development and Distribution License (the "License").
-# You may not use this file except in compliance with the License.
-#
-# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
-# or http://www.opensolaris.org/os/licensing.
-# See the License for the specific language governing permissions
-# and limitations under the License.
-#
-# When distributing Covered Code, include this CDDL HEADER in each
-# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
-# If applicable, add the following below this CDDL HEADER, with the
-# fields enclosed by brackets "[]" replaced with your own identifying
-# information: Portions Copyright [yyyy] [name of copyright owner]
-#
-# CDDL HEADER END
-#
-
-#
-# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
-# Use is subject to license terms.
-#
-# ident	"@(#)Makefile.files	1.159	08/05/26 SMI"
-#
-#	This Makefile defines file modules in the directory uts/i86pc
-#	and its children. These are the source files which are i86pc
-#	"implementation architecture" dependent.
-#
-
-#
-#	object lists
-#
-CORE_OBJS +=			\
-	acpi_stubs.o		\
-	biosdisk.o		\
-	bios_call.o		\
-	cbe.o			\
-	cmi.o			\
-	cmi_hw.o		\
-	cms.o			\
-	confunix.o		\
-	cpuid.o			\
-	cpupm.o			\
-	dis_tables.o		\
-	ddi_impl.o		\
-	dtrace_subr.o		\
-	dvma.o			\
-	fpu_subr.o		\
-	fakebop.o		\
-	graphics.o		\
-	hardclk.o		\
-	hat_i86.o		\
-	hat_kdi.o		\
-	hment.o			\
-	hold_page.o		\
-	hrtimers.o		\
-	htable.o		\
-	i86_mmu.o		\
-	instr_size.o		\
-	intr.o			\
-	kboot_mmu.o		\
-	kdi_subr.o		\
-	kdi_idt.o		\
-	kdi_idthdl.o		\
-	kdi_asm.o		\
-	lgrpplat.o		\
-	mach_kdi.o		\
-	mach_sysconfig.o	\
-	machdep.o		\
-	mem_config_stubs.o	\
-	memnode.o		\
-	microcode.o		\
-	microfind.o		\
-	mlsetup.o		\
-	mp_call.o		\
-	mp_implfuncs.o		\
-	mp_machdep.o		\
-	mp_pc.o			\
-	mp_startup.o		\
-	memscrub.o		\
-	mpcore.o		\
-	notes.o			\
-	pci_bios.o		\
-	pci_cfgspace.o		\
-	pci_mech1.o		\
-	pci_mech2.o		\
-	pci_neptune.o		\
-	pci_orion.o		\
-	pmem.o			\
-	ppage.o			\
-	startup.o		\
-	timestamp.o		\
-	todpc_subr.o		\
-	trap.o			\
-	vm_machdep.o		\
-	x_call.o
-
-#
-#	Add the SMBIOS subsystem object files directly to the list of objects
-#	built into unix itself; this is all common code except for smb_dev.c.
-#
-CORE_OBJS += $(SMBIOS_OBJS)
-
-#
-# These get compiled twice:
-# - once in the dboot (direct boot) identity mapped code
-# - once for use during early startup in unix
-#
-BOOT_DRIVER_OBJS =		\
-	boot_console.o		\
-	boot_keyboard.o		\
-	boot_keyboard_table.o	\
-	boot_vga.o		\
-	boot_mmu.o
-
-CORE_OBJS += $(BOOT_DRIVER_OBJS)
-
-#
-#	locore.o is special. It must be the first file relocated so that it
-#	it is relocated just where its name implies.
-#
-SPECIAL_OBJS_32 +=		\
-	locore.o		\
-	fast_trap_asm.o		\
-	interrupt.o		\
-	syscall_asm.o
-
-SPECIAL_OBJS_64 +=		\
-	locore.o		\
-	fast_trap_asm.o		\
-	interrupt.o		\
-	syscall_asm_amd64.o
-
-SPECIAL_OBJS += $(SPECIAL_OBJS_$(CLASS))
-
-#
-# Objects that get compiled into the identity mapped PT_LOAD section of unix
-# to handle the earliest part of booting.
-#
-DBOOT_OBJS_32 =
-
-DBOOT_OBJS_64 += dboot_elfload.o
-
-DBOOT_OBJS +=			\
-	dboot_asm.o		\
-	dboot_grub.o		\
-	dboot_printf.o		\
-	dboot_startkern.o	\
-	memcpy.o		\
-	memset.o		\
-	muldiv.o		\
-	string.o		\
-	$(BOOT_DRIVER_OBJS)	\
-	$(DBOOT_OBJS_$(CLASS))
-
-#
-#			driver and misc modules
-#
-GFX_PRIVATE_OBJS	+= gfx_private.o gfxp_pci.o gfxp_segmap.o \
-			   gfxp_devmap.o gfxp_vgatext.o gfxp_vm.o vgasubr.o
-ISANEXUS_OBJS += isa.o dma_engine.o i8237A.o
-PCI_E_MISC_OBJS += pcie.o pcie_fault.o
-PCI_E_NEXUS_OBJS += npe.o npe_misc.o
-PCI_E_NEXUS_OBJS += pci_common.o pci_kstats.o pci_tools.o
-PCINEXUS_OBJS += pci.o pci_common.o pci_kstats.o pci_tools.o
-PCPLUSMP_OBJS += apic.o psm_common.o apic_introp.o mp_platform_common.o
-VBI_OBJS += vbi.o
-
-BATTERY_OBJS	+= battery.o
-include $(SRC)/common/mc/mc-amd/Makefile.mcamd
-MCAMD_OBJS	+= \
-	$(MCAMD_CMN_OBJS) \
-	mcamd_drv.o \
-	mcamd_dimmcfg.o \
-	mcamd_subr.o \
-	mcamd_pcicfg.o
-
-CPUDRV_OBJS	+= cpudrv.o cpudrv_plat.o cpu_acpi.o speedstep.o pwrnow.o
-PPM_OBJS	+= ppm_subr.o ppm.o ppm_plat.o
-
-ACPIPPM_OBJS	+= acpippm.o acpisleep.o
-
-ROOTNEX_OBJS += rootnex.o
-TZMON_OBJS	+= tzmon.o
-UPPC_OBJS += uppc.o psm_common.o
-XSVC_OBJS += xsvc.o
-PV_CMDK_OBJS	+= pv_cmdk.o
-HVM_BOOTSTRAP_OBJS	+= hvm_bootstrap.o
-XDF_OBJS	+= xdf.o
-XNF_OBJS	+= xnf.o
-XPV_OBJS	+= xpv_support.o xvdi.o gnttab.o evtchn.o \
-		xenbus_comms.o xenbus_client.o xenbus_probe.o xenbus_xs.o \
-		hypercall.o hypersubr.o
-XPVD_OBJS	+= xpvd.o
-
-#
-#	Build up defines and paths.
-#
-ALL_DEFS	+= -Di86pc
-INC_PATH	+= -I$(UTSBASE)/i86pc -I$(SRC)/common
-
-#
-# Since the assym files are derived, the dependencies must be explicit for
-# all files including this file. (This is only actually required in the
-# instance when the .nse_depinfo file does not exist.) It may seem that
-# the lint targets should also have a similar dependency, but they don't
-# since only C headers are included when #defined(__lint) is true.
-#
-
-ASSYM_DEPS      += 		\
-	copy.o			\
-	desctbls_asm.o		\
-	ddi_i86_asm.o		\
-	exception.o		\
-	fast_trap_asm.o		\
-	float.o			\
-	i86_subr.o		\
-	interrupt.o		\
-	lock_prim.o		\
-	locore.o		\
-	mpcore.o		\
-	sseblk.o		\
-	swtch.o			\
-	syscall_asm.o		\
-	syscall_asm_amd64.o	\
-	cpr_wakecode.o
-
-CPR_IMPL_OBJS	= cpr_impl.o	cpr_wakecode.o
-
-$(KDI_ASSYM_DEPS:%=$(OBJS_DIR)/%):	$(DSF_DIR)/$(OBJS_DIR)/kdi_assym.h
-
-ASSYM_DEPS += kdi_asm.o
Index: unk/src/VBox/Runtime/r0drv/solaris/vbi/i86pc/Makefile.files.patch
===================================================================
--- /trunk/src/VBox/Runtime/r0drv/solaris/vbi/i86pc/Makefile.files.patch	(revision 40049)
+++ 	(revision )
@@ -1,19 +1,0 @@
---- old/usr/src/uts/i86pc/Makefile.files	Tue May 27 01:20:43 2008
-+++ new/usr/src/uts/i86pc/Makefile.files	Tue May 27 01:20:43 2008
-@@ -23,7 +23,7 @@
- # Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
- # Use is subject to license terms.
- #
--# ident	"@(#)Makefile.files	1.158	08/03/29 SMI"
-+# ident	"@(#)Makefile.files	1.159	08/05/26 SMI"
- #
- #	This Makefile defines file modules in the directory uts/i86pc
- #	and its children. These are the source files which are i86pc
-@@ -167,6 +167,7 @@
- PCI_E_NEXUS_OBJS += pci_common.o pci_kstats.o pci_tools.o
- PCINEXUS_OBJS += pci.o pci_common.o pci_kstats.o pci_tools.o
- PCPLUSMP_OBJS += apic.o psm_common.o apic_introp.o mp_platform_common.o
-+VBI_OBJS += vbi.o
- 
- BATTERY_OBJS	+= battery.o
- include $(SRC)/common/mc/mc-amd/Makefile.mcamd
Index: unk/src/VBox/Runtime/r0drv/solaris/vbi/i86pc/Makefile.i86pc.shared
===================================================================
--- /trunk/src/VBox/Runtime/r0drv/solaris/vbi/i86pc/Makefile.i86pc.shared	(revision 40049)
+++ 	(revision )
@@ -1,316 +1,0 @@
-#
-# CDDL HEADER START
-#
-# The contents of this file are subject to the terms of the
-# Common Development and Distribution License (the "License").
-# You may not use this file except in compliance with the License.
-#
-# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
-# or http://www.opensolaris.org/os/licensing.
-# See the License for the specific language governing permissions
-# and limitations under the License.
-#
-# When distributing Covered Code, include this CDDL HEADER in each
-# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
-# If applicable, add the following below this CDDL HEADER, with the
-# fields enclosed by brackets "[]" replaced with your own identifying
-# information: Portions Copyright [yyyy] [name of copyright owner]
-#
-# CDDL HEADER END
-#
-
-#
-# uts/i86pc/Makefile.i86pc
-#
-# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
-# Use is subject to license terms.
-#
-# ident	"@(#)Makefile.i86pc.shared	1.25	08/05/26 SMI"
-#
-#	This makefile contains the common definitions for the i86pc unix
-#	and all i86pc implementation architecture dependent modules.
-#
-
-#
-#	Machine type (implementation architecture):
-#
-PLATFORM	 = i86pc
-
-#
-#	uname -m value
-#
-UNAME_M		= $(PLATFORM)
-
-#
-#	Everybody needs to know how to build modstubs.o and to locate unix.o
-#
-UNIX_DIR	 = $(UTSBASE)/$(PLATFORM)/unix
-GENLIB_DIR	 = $(UTSBASE)/intel/genunix
-MODSTUBS_DIR	 = $(UNIX_DIR)
-DSF_DIR		 = $(UTSBASE)/$(PLATFORM)/genassym
-LINTS_DIR	 = $(OBJS_DIR)
-LINT_LIB_DIR	 = $(UTSBASE)/$(PLATFORM)/lint-libs/$(OBJS_DIR)
-GEN_LINT_LIB_DIR = $(UTSBASE)/intel/lint-libs/$(OBJS_DIR)
-
-DTRACESTUBS_O	 = $(OBJS_DIR)/dtracestubs.o
-DTRACESTUBS	 = $(OBJS_DIR)/libdtracestubs.so
-
-SYM_MOD		= $(OBJS_DIR)/unix.sym
-
-UNIX_O		 = $(UNIX_DIR)/$(OBJS_DIR)/unix.o
-MODSTUBS_O	 = $(MODSTUBS_DIR)/$(OBJS_DIR)/modstubs.o
-GENLIB	 	 = $(GENLIB_DIR)/$(OBJS_DIR)/libgenunix.so
-LINT_LIB	 = $(LINT_LIB_DIR)/llib-lunix.ln
-DBOOT_LINT_LIB	 = $(LINT_LIB_DIR)/llib-ldboot.ln
-GEN_LINT_LIB	 = $(GEN_LINT_LIB_DIR)/llib-lgenunix.ln
-
-#
-#	Include the makefiles which define build rule templates, the
-#	collection of files per module, and a few specific flags. Note
-#	that order is significant, just as with an include path. The
-#	first build rule template which matches the files name will be
-#	used. By including these in order from most machine dependent
-#	to most machine independent, we allow a machine dependent file
-#	to be used in preference over a machine independent version
-#	(Such as a machine specific optimization, which preserves the
-#	interfaces.)
-#
-include $(UTSTREE)/$(PLATFORM)/Makefile.files
-include $(UTSTREE)/intel/Makefile.files
-include $(UTSTREE)/common/Makefile.files
-
-#
-#	Include machine independent rules. Note that this does not imply
-#	that the resulting module from rules in Makefile.uts is	machine
-#	independent. Only that the build rules are machine independent.
-#
-include $(UTSBASE)/Makefile.uts
-
-#
-#	Define supported builds
-#
-DEF_BUILDS		= $(DEF_BUILDS64) $(DEF_BUILDS32)
-ALL_BUILDS		= $(ALL_BUILDS64) $(ALL_BUILDS32)
-
-#
-#	x86 or amd64 inline templates
-#
-INLINES_32		= $(UTSBASE)/intel/ia32/ml/ia32.il \
-			  $(UTSBASE)/$(PLATFORM)/ml/ia32.il
-INLINES_64		= $(UTSBASE)/intel/amd64/ml/amd64.il \
-			  $(UTSBASE)/$(PLATFORM)/ml/amd64.il
-INLINES			+= $(INLINES_$(CLASS))
-
-#
-#	kernel-specific optimizations; override default in Makefile.master
-#
-
-CFLAGS_XARCH_32		= $(i386_CFLAGS)
-CFLAGS_XARCH_64		= $(amd64_CFLAGS)
-CFLAGS_XARCH		= $(CFLAGS_XARCH_$(CLASS))
-
-COPTFLAG_32		= $(COPTFLAG)
-COPTFLAG_64		= $(COPTFLAG64)
-COPTIMIZE		= $(COPTFLAG_$(CLASS))
-
-CFLAGS			= $(CFLAGS_XARCH)
-CFLAGS			+= $(COPTIMIZE)
-CFLAGS			+= $(INLINES) -D_ASM_INLINES
-CFLAGS			+= $(CCMODE)
-CFLAGS			+= $(SPACEFLAG)
-CFLAGS			+= $(CCUNBOUND)
-CFLAGS			+= $(CFLAGS_uts)
-CFLAGS			+= -xstrconst
-
-ASFLAGS_XARCH_32	= $(i386_ASFLAGS)
-ASFLAGS_XARCH_64	= $(amd64_ASFLAGS)
-ASFLAGS_XARCH		= $(ASFLAGS_XARCH_$(CLASS))
-
-ASFLAGS			+= $(ASFLAGS_XARCH)
-
-AS_INC_PATH		+= -I$(DSF_DIR)/$(OBJS_DIR)
-
-#
-#	The following must be defined for all implementations:
-#
-#	MAPFILE:	ld mapfile for the build of kernel/unix.
-#	MODSTUBS:	Module stubs source file.
-#	GENASSYM_SRC:	genassym.c
-#
-MAPFILE		 = $(UTSBASE)/$(PLATFORM)/conf/Mapfile
-MODSTUBS	 = $(UTSBASE)/intel/ia32/ml/modstubs.s
-GENASSYM_SRC	 = $(UTSBASE)/$(PLATFORM)/ml/genassym.c
-OFFSETS_SRC	 = $(UTSBASE)/$(PLATFORM)/ml/offsets.in
-PLATFORM_OFFSETS_32	= $(UTSBASE)/$(PLATFORM)/ml/mach_offsets.in
-PLATFORM_OFFSETS_64	= $(UTSBASE)/intel/amd64/ml/mach_offsets.in
-PLATFORM_OFFSETS_SRC	= $(PLATFORM_OFFSETS_$(CLASS))
-KDI_OFFSETS_SRC	 = $(UTSBASE)/intel/kdi/kdi_offsets.in
-
-#
-#	Define the actual specific platforms
-#
-MACHINE_DEFS	 = -D$(PLATFORM) -D_MACHDEP
-
-#
-#	Software workarounds for hardware "features"
-#
-
-include	$(UTSBASE)/$(PLATFORM)/Makefile.workarounds
-
-#
-#	Debugging level
-#
-#	Special knowledge of which special debugging options effect which
-#	file is used to optimize the build if these flags are changed.
-#
-#	XXX: The above could possibly be done for more flags and files, but
-#	     is left as an experiment to the interested reader. Be forewarned,
-#	     that excessive use could lead to maintenance difficulties.
-#
-DEBUG_DEFS_OBJ32	=
-DEBUG_DEFS_DBG32	= -DDEBUG
-DEBUG_DEFS_OBJ64	=
-DEBUG_DEFS_DBG64	= -DDEBUG
-DEBUG_DEFS		= $(DEBUG_DEFS_$(BUILD_TYPE))
-
-DEBUG_COND_OBJ32	:sh = echo \\043
-DEBUG_COND_DBG32	=
-DEBUG_COND_OBJ64	:sh = echo \\043
-DEBUG_COND_DBG64	=
-IF_DEBUG_OBJ		= $(DEBUG_COND_$(BUILD_TYPE))$(OBJS_DIR)/
-
-$(IF_DEBUG_OBJ)trap.o		:= DEBUG_DEFS += -DTRAPDEBUG -DTRAPTRACE
-$(IF_DEBUG_OBJ)syscall_asm.o	:= DEBUG_DEFS += -DSYSCALLTRACE -DTRAPTRACE
-$(IF_DEBUG_OBJ)syscall_asm_amd64.o := DEBUG_DEFS += -DSYSCALLTRACE -DTRAPTRACE
-$(IF_DEBUG_OBJ)fast_trap_asm.o	:= DEBUG_DEFS += -DTRAPTRACE
-$(IF_DEBUG_OBJ)interrupt.o	:= DEBUG_DEFS += -DTRAPTRACE
-$(IF_DEBUG_OBJ)intr.o		:= DEBUG_DEFS += -DTRAPTRACE
-$(IF_DEBUG_OBJ)locore.o		:= DEBUG_DEFS += -DTRAPTRACE
-$(IF_DEBUG_OBJ)mp_startup.o	:= DEBUG_DEFS += -DTRAPTRACE
-$(IF_DEBUG_OBJ)machdep.o	:= DEBUG_DEFS += -DTRAPTRACE
-$(IF_DEBUG_OBJ)exception.o	:= DEBUG_DEFS += -DTRAPTRACE
-$(IF_DEBUG_OBJ)x_call.o		:= DEBUG_DEFS += -DTRAPTRACE
-$(IF_DEBUG_OBJ)mp_call.o	:= DEBUG_DEFS += -DTRAPTRACE
-$(IF_DEBUG_OBJ)cbe.o		:= DEBUG_DEFS += -DTRAPTRACE
-
-#
-#	Collect the preprocessor definitions to be associated with *all*
-#	files.
-#
-ALL_DEFS	 = $(MACHINE_DEFS) $(WORKAROUND_DEFS) $(DEBUG_DEFS) \
-		   $(OPTION_DEFS)
-GENASSYM_DEFS	 = $(MACHINE_DEFS) $(OPTION_DEFS) \
-			-_gcc=-fno-eliminate-unused-debug-symbols \
-			-_gcc=-fno-eliminate-unused-debug-types
-
-#
-# ----- TRANSITIONAL SECTION --------------------------------------------------
-#
-
-#
-#	Not everything which *should* be a module is a module yet. The
-#	following is a list of such objects which are currently part of
-#	the base kernel but should soon become kmods.
-#
-#	XXX: $(KMACCT_OBJS) is neither in the MT kernel nor was it ever
-#	     made into a module. If it is made MT safe before being made
-#	     into a module, it should be added to this list. It was in
-#	     this list pre ON-4.0.
-#
-#
-MACH_NOT_YET_KMODS	= $(AUTOCONF_OBJS)
-
-#
-# ----- END OF TRANSITIONAL SECTION -------------------------------------------
-#
-
-#
-#	The kernels modules which are "implementation architecture"
-#	specific for this machine are enumerated below. Note that most
-#	of these modules must exist (in one form or another) for each
-#	architecture.
-#
-#	Machine Specific Driver Modules (/kernel/drv)
-#	DRV_KMODS are built both 32-bit and 64-bit
-#	DRV_KMODS_32 are built only 32-bit
-#	DRV_KMODS_64 are built only 64-bit
-#
-DRV_KMODS	+= rootnex
-DRV_KMODS	+= isa
-DRV_KMODS	+= pcplusmp
-DRV_KMODS	+= cpc
-DRV_KMODS	+= pci
-DRV_KMODS	+= npe
-DRV_KMODS	+= pci-ide
-DRV_KMODS	+= xsvc
-DRV_KMODS	+= mc-amd
-DRV_KMODS	+= tzmon
-DRV_KMODS	+= battery
-DRV_KMODS	+= pv_cmdk
-DRV_KMODS	+= xdf
-DRV_KMODS	+= xnf
-DRV_KMODS	+= xpv
-DRV_KMODS	+= xpvd
-
-DRV_KMODS	+= cpudrv
-
-#
-# Platform Power Modules
-# 
-DRV_KMODS	+= ppm acpippm
-
-$(CLOSED_BUILD)CLOSED_DRV_KMODS		+= memtest
-
-#
-#	CPU Modules
-#
-CPU_KMODS	+= amd_opteron
-CPU_KMODS	+= generic_cpu
-CPU_KMODS	+= authenticamd
-CPU_KMODS	+= genuineintel
-CPU_KMODS	+= intel_nb5000
-
-#
-#	Exec Class Modules (/kernel/exec):
-#
-EXEC_KMODS	+=
-
-#
-#	Scheduling Class Modules (/kernel/sched):
-#
-SCHED_KMODS	+=
-
-#
-#	File System Modules (/kernel/fs):
-#
-FS_KMODS	+=
-
-#
-#	Streams Modules (/kernel/strmod):
-#
-STRMOD_KMODS	+=
-
-#
-#	'System' Modules (/kernel/sys):
-#
-SYS_KMODS	+=
-
-#
-#	'Misc' Modules (/kernel/misc):
-#
-MISC_KMODS	+= gfx_private pcie hvm_bootstrap vbi
-
-#
-#	'Dacf' modules (/kernel/dacf)
-#
-DACF_KMODS	+= consconfig_dacf
-
-#
-#	'Mach' Modules (/kernel/mach):
-#
-MACH_KMODS     	+= uppc
-
-#
-#	CPR Misc Module.
-#
-MISC_KMODS	+= cpr
Index: unk/src/VBox/Runtime/r0drv/solaris/vbi/i86pc/Makefile.i86pc.shared.patch
===================================================================
--- /trunk/src/VBox/Runtime/r0drv/solaris/vbi/i86pc/Makefile.i86pc.shared.patch	(revision 40049)
+++ 	(revision )
@@ -1,20 +1,0 @@
---- old/usr/src/uts/i86pc/Makefile.i86pc.shared	Tue May 27 01:20:43 2008
-+++ new/usr/src/uts/i86pc/Makefile.i86pc.shared	Tue May 27 01:20:43 2008
-@@ -25,7 +25,7 @@
- # Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
- # Use is subject to license terms.
- #
--# ident	"@(#)Makefile.i86pc.shared	1.24	08/03/28 SMI"
-+# ident	"@(#)Makefile.i86pc.shared	1.25	08/05/26 SMI"
- #
- #	This makefile contains the common definitions for the i86pc unix
- #	and all i86pc implementation architecture dependent modules.
-@@ -298,7 +298,7 @@
- #
- #	'Misc' Modules (/kernel/misc):
- #
--MISC_KMODS	+= gfx_private pcie hvm_bootstrap
-+MISC_KMODS	+= gfx_private pcie hvm_bootstrap vbi
- 
- #
- #	'Dacf' modules (/kernel/dacf)