Index: trunk/src/VBox/Additions/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/Makefile.kmk	(revision 39749)
+++ trunk/src/VBox/Additions/Makefile.kmk	(revision 40315)
@@ -59,7 +59,7 @@
   include $(PATH_SUB_CURRENT)/linux/Makefile.kmk
  endif
- #ifeq ($(KBUILD_TARGET),os2)
- # include $(PATH_SUB_CURRENT)/os2/Makefile.kmk
- #endif
+ ifeq ($(KBUILD_TARGET),os2)
+  include $(PATH_SUB_CURRENT)/os2/Makefile.kmk
+ endif
  ifeq ($(KBUILD_TARGET),solaris)
   include $(PATH_SUB_CURRENT)/solaris/Makefile.kmk
@@ -170,4 +170,19 @@
 #
 
+# Darwin / Mac OS X			   
+ifdef VBOX_WITH_ADDITIONS_ISO.darwin.x86
+ VBOX_PATH_ADDITIONS.darwin.x86 = $(PATH_OUT_BASE)/darwin.x86/$(KBUILD_TYPE)/bin/additions
+ # or dmg?
+ GUESTADDITIONS_FILESPEC.darwin.x86 = \
+	VBoxDarwinAdditions-x86.run=$(VBOX_PATH_ADDITIONS.darwin.x86)/VBoxDarwinAdditions-x86.run
+endif
+
+ifdef VBOX_WITH_ADDITIONS_ISO.darwin.amd64
+ VBOX_PATH_ADDITIONS.darwin.amd64 = $(PATH_OUT_BASE)/darwin.amd64/$(KBUILD_TYPE)/bin/additions
+ GUESTADDITIONS_FILESPEC.darwin.amd64 = \
+	VBoxDarwinAdditions-amd64.run=$(VBOX_PATH_ADDITIONS.darwin.amd64)/VBoxDarwinAdditions-amd64.run
+endif
+
+# FreeBSD
 ifdef VBOX_WITH_ADDITIONS_ISO.freebsd.amd64
  VBOX_PATH_ADDITIONS.freebsd.amd64 = $(PATH_OUT_BASE)/freebsd.amd64/$(KBUILD_TYPE)/bin/additions
@@ -181,14 +196,40 @@
 endif
 
-
+# GNU/Linux
+ifdef VBOX_WITH_ADDITIONS_ISO.linux.amd64
+ VBOX_PATH_ADDITIONS.linux.amd64 = $(PATH_OUT_BASE)/linux.amd64/$(KBUILD_TYPE)/bin/additions
+ ifdef VBOX_WITH_COMBINED_LINUX_GUEST_PACKAGE
+  VBOX_LNX_ADD_AMD64_RUN_PKG=VBoxLinuxAdditions.run
+ else
+  VBOX_LNX_ADD_AMD64_RUN_PKG=VBoxLinuxAdditions-amd64.run
+ endif
+ GUESTADDITIONS_FILESPEC.linux.amd64 = \
+	$(VBOX_LNX_ADD_AMD64_RUN_PKG)=$(VBOX_PATH_ADDITIONS.linux.amd64)/VBoxLinuxAdditions.run
+endif
+ifdef VBOX_WITH_ADDITIONS_ISO.linux.x86
+ VBOX_PATH_ADDITIONS.linux.x86 = $(PATH_OUT_BASE)/linux.x86/$(KBUILD_TYPE)/bin/additions
+## @todo 64-bit additions: rename this package, update docs (?) and tests (?). create wrapper? create gnome/kde autorun app (xplatform) ?
+ ifdef VBOX_WITH_COMBINED_LINUX_GUEST_PACKAGE
+  VBOX_LNX_ADD_X86_RUN_PKG=VBoxLinuxAdditions.run
+ else
+  VBOX_LNX_ADD_X86_RUN_PKG=VBoxLinuxAdditions-x86.run
+ endif
+ GUESTADDITIONS_FILESPEC.linux.x86 = \
+	$(VBOX_LNX_ADD_X86_RUN_PKG)=$(VBOX_PATH_ADDITIONS.linux.x86)/VBoxLinuxAdditions.run \
+	runasroot.sh=$(VBOX_PATH_ADDITIONS.linux.x86)/runasroot.sh \
+	autorun.sh=$(VBOX_PATH_ADDITIONS.linux.x86)/autorun.sh
+endif
+
+# IBM OS/2
 ifdef VBOX_WITH_ADDITIONS_ISO.os2.x86
  VBOX_PATH_ADDITIONS.os2.x86 = $(PATH_OUT_BASE)/os2.x86/$(KBUILD_TYPE)/bin/additions
  GUESTADDITIONS_FILESPEC.os2.x86 = \
-	32Bit/OS2/VBoxGuest.sys=$(VBOX_PATH_ADDITIONS.os2.x86)/VBoxGuest.sys \
-	32Bit/OS2/VBoxService.exe=$(VBOX_PATH_ADDITIONS.os2.x86)/VBoxService.exe \
-	32Bit/OS2/gengradd.dll=$(VBOX_PATH_ADDITIONS.os2.x86)/gengradd.dll \
-	32Bit/OS2/libc063.dll=$(VBOX_PATH_ADDITIONS_SRC)/os2/Bin/libc063.dll \
-	32Bit/OS2/readme.txt=$(VBOX_PATH_ADDITIONS_SRC)/os2/Bin/readme.txt \
-	32Bit/OS2/vboxmouse.sys=$(VBOX_PATH_ADDITIONS.os2.x86)/vboxmouse.sys
+	OS2/VBoxGuest.sys=$(VBOX_PATH_ADDITIONS.os2.x86)/VBoxGuest.sys \
+	OS2/VBoxService.exe=$(VBOX_PATH_ADDITIONS.os2.x86)/VBoxService.exe \
+	OS2/VBoxControl.exe=$(VBOX_PATH_ADDITIONS.os2.x86)/VBoxControl.exe \
+	OS2/gengradd.dll=$(VBOX_PATH_ADDITIONS.os2.x86)/gengradd.dll \
+	OS2/libc064.dll=$(VBOX_PATH_ADDITIONS_SRC)/os2/Bin/libc064.dll \
+	OS2/readme.txt=$(VBOX_PATH_ADDITIONS_SRC)/os2/Bin/readme.txt \
+	OS2/vboxmouse.sys=$(VBOX_PATH_ADDITIONS.os2.x86)/vboxmouse.sys
 else ifdef VBOX_WITH_OS2_ADDITIONS_BIN
  GUESTADDITIONS_FILESPEC.os2.x86 = \
@@ -201,29 +242,5 @@
 endif
 
-
-ifdef VBOX_WITH_ADDITIONS_ISO.linux.amd64
- VBOX_PATH_ADDITIONS.linux.amd64 = $(PATH_OUT_BASE)/linux.amd64/$(KBUILD_TYPE)/bin/additions
- ifdef VBOX_WITH_COMBINED_LINUX_GUEST_PACKAGE
-  VBOX_LNX_ADD_AMD64_RUN_PKG=VBoxLinuxAdditions.run
- else
-  VBOX_LNX_ADD_AMD64_RUN_PKG=VBoxLinuxAdditions-amd64.run
- endif
- GUESTADDITIONS_FILESPEC.linux.amd64 = \
-	$(VBOX_LNX_ADD_AMD64_RUN_PKG)=$(VBOX_PATH_ADDITIONS.linux.amd64)/VBoxLinuxAdditions.run
-endif
-ifdef VBOX_WITH_ADDITIONS_ISO.linux.x86
- VBOX_PATH_ADDITIONS.linux.x86 = $(PATH_OUT_BASE)/linux.x86/$(KBUILD_TYPE)/bin/additions
-## @todo 64-bit additions: rename this package, update docs (?) and tests (?). create wrapper? create gnome/kde autorun app (xplatform) ?
- ifdef VBOX_WITH_COMBINED_LINUX_GUEST_PACKAGE
-  VBOX_LNX_ADD_X86_RUN_PKG=VBoxLinuxAdditions.run
- else
-  VBOX_LNX_ADD_X86_RUN_PKG=VBoxLinuxAdditions-x86.run
- endif
- GUESTADDITIONS_FILESPEC.linux.x86 = \
-	$(VBOX_LNX_ADD_X86_RUN_PKG)=$(VBOX_PATH_ADDITIONS.linux.x86)/VBoxLinuxAdditions.run \
-	runasroot.sh=$(VBOX_PATH_ADDITIONS.linux.x86)/runasroot.sh \
-	autorun.sh=$(VBOX_PATH_ADDITIONS.linux.x86)/autorun.sh
-endif
-
+# Oracle Solaris.
 ifdef VBOX_WITH_ADDITIONS_ISO.solaris.amd64
  VBOX_PATH_ADDITIONS.solaris.amd64 = $(PATH_OUT_BASE)/solaris.amd64/$(KBUILD_TYPE)/bin/additions
@@ -245,4 +262,5 @@
 endif
 
+# Microsoft Windows.
 ifdef VBOX_WITH_ADDITIONS_ISO.win.amd64
  VBOX_PATH_ADDITIONS.win.amd64 = $(PATH_OUT_BASE)/win.amd64/$(KBUILD_TYPE)/bin/additions
@@ -268,16 +286,4 @@
 endif # win.x86
 
-ifdef VBOX_WITH_ADDITIONS_ISO.darwin.x86
- VBOX_PATH_ADDITIONS.darwin.x86 = $(PATH_OUT_BASE)/darwin.x86/$(KBUILD_TYPE)/bin/additions
- # or dmg?
- GUESTADDITIONS_FILESPEC.darwin.x86 = \
-	VBoxDarwinAdditions-x86.run=$(VBOX_PATH_ADDITIONS.darwin.x86)/VBoxDarwinAdditions-x86.run
-endif
-
-ifdef VBOX_WITH_ADDITIONS_ISO.darwin.amd64
- VBOX_PATH_ADDITIONS.darwin.amd64 = $(PATH_OUT_BASE)/darwin.amd64/$(KBUILD_TYPE)/bin/additions
- GUESTADDITIONS_FILESPEC.darwin.amd64 = \
-	VBoxDarwinAdditions-amd64.run=$(VBOX_PATH_ADDITIONS.darwin.amd64)/VBoxDarwinAdditions-amd64.run
-endif
 
 #