Index: trunk/doc/manual/en_US/user_Troubleshooting.xml
===================================================================
--- trunk/doc/manual/en_US/user_Troubleshooting.xml	(revision 40456)
+++ trunk/doc/manual/en_US/user_Troubleshooting.xml	(revision 40457)
@@ -745,13 +745,13 @@
       <title>USB tablet coordinates wrong in Windows 98 guests</title>
 
-      <para>If a Windows 98 VM is configured to use the emulated USB tablet 
-      (absolute pointing device), the coordinate translation may be incorrect 
-      and the pointer is restricted to the upper left quarter of the guest's 
+      <para>If a Windows 98 VM is configured to use the emulated USB tablet
+      (absolute pointing device), the coordinate translation may be incorrect
+      and the pointer is restricted to the upper left quarter of the guest's
       screen.
       </para>
 
-      <para>The USB HID (Human Interface Device) drivers in Windows 98 are very 
-          old and do not handle tablets the same way all more recent operating 
-          systems do (Windows 2000 and later, Mac OS X, Solaris). To 
+      <para>The USB HID (Human Interface Device) drivers in Windows 98 are very
+          old and do not handle tablets the same way all more recent operating
+          systems do (Windows 2000 and later, Mac OS X, Solaris). To
           work around the problem, issue the following command:
       </para>
@@ -783,22 +783,36 @@
     <sect2>
       <title>Restoring d3d8.dll and d3d9.dll</title>
-      
-      <para>VirtualBox Guest Additions installer prior 4.1.8 had an issue, that might cause system d3d9.dll and d3d8.dll files corruption.
-          Although this issue was fixed with VirtualBox 4.1.8, there is no way Guest Additions installer can repare these files.
-          Corruption of these files has no implications in case 3D acceleration is enabled and "Basic" Direct3D support is installed,
-          since all Direct3D9 and Direct3D8 applications will utilize VirtualBox Direct3D files and thus will have no problems with Direct3D.
-          For WDDM Direct3D support system d3d9.dll and d3d8.dll files are always required for Direct3D8 and Direct3D9 applications,
-          as a result Direct3D8 and Direct3D9 applications will not work.
-          Note that starting Windows 7, 3D Desktop (aka Aero) uses d3d10.dll for rendering, thus d3d9.dll and d3d8.dll files corruption will not affect it.
-          Given all the above, system d3d9.dll and d3d8.dll files corruption is not sonsidered fatal for "Basic" Direct3D installation,
-          and for WDDM Direct3D installation on Windows 7 and later guests. 
-      </para>
-      
-      <para>Below is a step-by step guide for restoring original system d3d8.dll and d3d9.dll files for the case it is required. 
-      </para>
-      
-
-      <para>Extracting d3d8 and d3d9.dll from Windows XP installation CD
-      </para>
+
+      <para>VirtualBox Guest Additions for Windows prior to 4.1.8 did not properly
+          back up the original d3d8.dll and d3d9.dll system files when selecting
+          and installing the experimental Direct3D support. This process replaces
+          both system files with files from the VirtualBox Guest Additions so that
+          Direct3D calls can be handled correctly. Although this issue was fixed
+          with VirtualBox 4.1.8, there is no way the Windows Guest Additions
+          installer can repair these files.</para>
+
+      <para>Corruption of these files has no implications in case 3D acceleration
+          is enabled and basic Direct3D support is installed, that is, without WDDM
+          (on Windows Vista or higher) or on older Windows systems like Windows XP.
+          With the basic Direct3D support all Direct3D 8.0 and Direct3D 9.0
+          applications will utilize VirtualBox Direct3D files directly and thus
+          will run as expected.</para>
+
+      <para>For WDDM Direct3D support however, the originally shipped system files
+          d3d8.dll and d3d9.dll files are required in order to run Direct3D 8.0
+          and Direct3D 9.0 applications. As a result of the above mentioned system
+          files corruption these applications will not work anymore. See below for
+          a step-by-step guide for restoring the original d3d8.dll and d3d9.dll
+          system files in case the VirtualBox Guest Additions installer warned
+          about those incorrect files or when having trouble running Direct3D
+          applications.</para>
+
+      <note><para>Starting at Windows 7 the 3D desktop (aka Aero) uses DirectX 10
+          for rendering so that corrupted d3d8.dll and d3d9.dll system files will
+          have no effect on the actual rendering. Taken this into account such a
+          detected file corruption will not be considered as fatal for the basic
+          Direct3D and WDDM Direct3D installation on Windows 7 and later guests.</para></note>
+
+      <para>Extracting d3d8 and d3d9.dll from a Windows XP installation CD:</para>
 
       <orderedlist>